// valtozo a jatekter tarolasara
let game_area;
// offset a kartyak kozott x iranyban
let offset_l = 25;
// offset kartyak kozott y iranyban
let offset_t = 50;
// ezen az x pozicion legyen az elso megjelenitett kartya
let left_offset = 90;
// ezen az y pozicion legyen az elso megjelenitett kartya
let top_offset = 100;

// valtozo arra, hogy nem volt kartya kijelolve
let lst_card = -1;

// kartyakat tartalmazo sorok szama
let rows = 5;

// egy sorban levo kartyak szama
let cards_num = 10;

// tomb a kartyak ellenorzesehez
let card_check_arr = [];
// tomb feltoltese. amennyiben nem lesz kartya az adott indexen, ugy az 1-es erteket vesszuk fel az adott tombindexre
for (let cr = 0; cr < rows; cr++) {
    // egy sorban levo elemek tombje
    let arr = [];
    // elemek hozzaadasa
    for (let cc = 0; cc < cards_num; cc++) {
        if (cc < cr) {
            arr[cc] = 1;
        } else {
            arr[cc] = 0;
        }
    }
    // adott sor kartyainak hozzaadasa a kartyas tombhoz
    card_check_arr[cr] = arr;
}

// kartya szelessege
let card_w = 150;
// kartya magassaga
let card_h = 217;
// beolvasott kartyak
let cards = [];
// osszes kartya osszegyujtese
for (let i = 0; i < 10; i++) {
    cards[i] = new Image();
    cards[i].src = (i + 1) + '_of_diamonds.png';
}

// ha betoltodott a weboldal
$(document).ready(function () {
    // beallitjuk a jatekter tulajdonsagait
    game_area = $('#game_area');
    game_area.css({
        width: $(window).width(),
        height: $(window).height(),
        backgroundColor: 'green'
    });

    // kartyak kirajzolasa
    init_cards();

    // amennyiben billentyulenyomas tortenik es a lenyomott billentyu az "r", akkor ujra kattinthato barmely elerheto elem, ami nincs takarasban
    window.addEventListener('keydown', function (e) {
        if (e.key === 'r') {
            lst_card = -1;
        }
    });

    // ha egy kartyara kattintunk, akkor eltavolitjuk az osszesrol a glowing-border osztalyt és megnezzuk a kartya elerhetoseget
    $('.cards').on('click', function () {

        $('.cards').removeClass('glowing-border');
        check_cards_availability($(this));

    });
});


function init_cards() {
    // vegigmegyunk a sorokon es megjelenitjuk a kartyakat
    for (let r = 0; r < rows; r++) {
        for (let j = 0; j < cards_num; j++) {
            // random szam, random kartya valasztasahoz
            let c_num = Math.floor(Math.random() * cards.length);
            // kartya hozzaadasa a jatekterhez es beallitasok. a hatterkep az adott kartya lesz, a pozicioja az also sorban a default, egyebkent mindig ket kartya koze esik az uj sor eleme es eggyel kevesebb elem lesz
            let card = $('<div>');
            card.css({
                backgroundImage: "url(" + cards[c_num].src + ")",
                width: card_w,
                height: card_h,
                left: left_offset + left_offset * r + j * card_w + j * offset_l,
                top: top_offset + offset_t * r,
                position: 'absolute'
            });
            game_area.append(card);
            // osztaly a konnyu azonositashoz
            card.addClass('cards');
            card.addClass('card-border');
            // tarolja a kartya szamerteket
            card.attr('number', c_num);
            // tarolja, hogy hanyadik retegben van a kartya
            card.attr('layer', r);
            // egy soron belul, hanyadik elem
            card.attr('pos', j);
        }
        // mivel minden sorban az elozonel eggyel kevesebb elem van, igy csokkentjuk a cards_num erteket minden sorban
        cards_num--;
    }
}


function check_cards_availability(act_card) {
    // lekerjuk a poziciora, retegszamra, ertekre vonatkozo adatokat
    let act_pos = parseInt(act_card.attr('pos'));
    let act_layer = parseInt(act_card.attr('layer'));
    let act_num = parseInt(act_card.attr('number')) + 1;

    // amennyiben a legfelso lapok valamelyikere kattintottunk
    if (act_layer === rows - 1) {
        // ha meg nem volt elozo kattintas
        if (lst_card === -1) {
            // eltuntetjuk a kartyat
            remove_card(act_card);
            $('#message').text('');
            // beallitjuk a kartya erteket. a kovetkezo elem vizsgalatahoz fontos lesz, mert csak vagy eggyel kisebb vagy nagyobb erteku kartyara lehet kattintani
            lst_card = act_num;
            // az ellenorzo tombben a megfelelo poziciot megvaltoztatjuk 1-re, mert levettuk. ezt fogjuk arra hasznalni, hogy megvizsgaljuk, takarasban van-e a kattintott elem
            card_check_arr[act_layer][act_layer + act_pos] = 1;
        } else {
            // ha az elozo kattintas es az aktualis szomszedos szamok, akkor ugyanaz, mint az elozo agon
            if (lst_card - 1 === act_num || lst_card + 1 === act_num) {
                remove_card(act_card);
                $('#message').text('');
                lst_card = act_num;
                card_check_arr[act_layer][act_layer + act_pos] = 1;
            } else {
                // ha nem, akkor hozzadjuk a glowing-border osztalyt es kiirjuk, hogy valassz masikat
                act_card.addClass('glowing-border');
                $('#message').text('Válasz másik kártyát vagy nyomd meg az "R" billentyűt!');
            }
        }
    } else {
        // megvizsgaljuk, hogy fedesben van-e az elem es hogy szomszedos erteket kattintottunk-e
        if (card_check_arr[act_layer + 1][act_pos + act_layer] === 1 && card_check_arr[act_layer + 1][act_layer + act_pos + 1] === 1 && (lst_card - 1 === act_num || lst_card + 1 === act_num)) {
            remove_card(act_card);
            $('#message').text('');
            lst_card = act_num;
            card_check_arr[act_layer][act_layer + act_pos] = 1;
        } else {
            act_card.addClass('glowing-border');
            $('#message').text('Válasz másik kártyát vagy nyomd meg az "R" billentyűt!');
        }
        if (lst_card === -1 && card_check_arr[act_layer + 1][act_pos + act_layer] === 1 && card_check_arr[act_layer + 1][act_layer + act_pos + 1] === 1) {
            remove_card(act_card);
            $('#message').text('');
            lst_card = act_num;
            card_check_arr[act_layer][act_layer + act_pos] = 1;
        } else {
            act_card.addClass('glowing-border');
            $('#message').text('Válasz másik kártyát vagy nyomd meg az "R" billentyűt!');
        }
    }
}

// animacio a kartya egy masik poziciora tetelere. levesszuk a kartyakat megkulonboztato osztalyt az elemrol.
function remove_card(card) {
    card.animate({
        left: 100,
        top: 600,
    }, 150, function () {
        card.addClass('removed')
    });
    card.removeClass('cards');
}